import { useCssVars as Ce, computed as c, ref as p, onMounted as Le, openBlock as s, createElementBlock as n, normalizeClass as D, normalizeStyle as b, createVNode as Z, createCommentVNode as y, createBlock as ee, unref as h, createSlots as Ae, withCtx as k, renderSlot as x, normalizeProps as H, guardReactiveProps as U, Fragment as A, renderList as T, createElementVNode as u, toDisplayString as f, withKeys as ze, createTextVNode as Te, nextTick as Me } from "vue";
import { u as Se, o as Ne, e as ge, c as le, t as Oe, I as Fe, g as Ve, J as te, X as Ie, D as ae, i as Y, f as B, w as Pe, x as Be, q as Re, r as Ee } from "./index-CpHoINpJ.js";
import { _ as Ge } from "./Title-xP0rAF4q.js";
import { u as Xe, U as De } from "./usePrinter-BHy-mfVg.js";
import { _ as He } from "./Tooltip-DfBa_7Ur.js";
import Ue from "./vue-ui-skeleton-DuM6yey6.js";
import Ye from "./BaseIcon-Fm7sUbd2.js";
import je from "./vue-ui-accordion-BZloYo0L.js";
import { u as pe } from "./useNestedProp-BOjw3Yqn.js";
import { _ as We } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const qe = ["id"], Ke = ["xmlns", "viewBox"], Je = ["x", "y", "width", "height", "fill", "stroke", "stroke-width"], Qe = ["x", "y", "width", "height", "fill", "stroke", "stroke-width"], Ze = ["font-size", "font-weight", "fill", "x", "y"], el = ["x", "y", "width", "height", "onMouseover"], ll = { key: 0 }, tl = ["font-size", "fill", "x", "y", "font-weight"], al = { key: 0 }, ol = ["text-anchor", "font-size", "fill", "font-weight", "transform"], sl = { key: 1 }, ul = ["x", "y", "width", "height", "stroke", "stroke-width"], nl = { key: 2 }, il = ["id"], rl = ["stop-color"], dl = ["stop-color"], vl = ["x", "y", "font-size", "fill"], yl = ["x", "y", "height", "rx", "fill"], cl = ["x", "y", "font-size", "fill"], hl = ["stroke", "x1", "x2", "y1", "y2"], gl = ["fill", "d"], pl = { key: 3 }, fl = {
  id: "colorScaleHorizontal",
  x1: "0%",
  x2: "100%",
  y1: "0%",
  y2: "0%"
}, bl = ["stop-color"], ml = ["stop-color"], xl = ["x", "y", "width", "height", "rx"], wl = ["x", "y", "font-size", "fill"], _l = ["x", "y", "font-size", "fill"], kl = ["stroke", "x1", "x2", "y1", "y2"], $l = ["fill", "d"], Cl = {
  key: 3,
  class: "vue-data-ui-watermark"
}, Ll = { class: "vue-ui-data-table" }, Al = { key: 0 }, zl = ["data-cell"], Tl = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, Ml = ["data-cell"], Sl = { style: { display: "flex", "align-items": "center", gap: "5px", "justify-content": "flex-end", width: "100%", "padding-right": "3px" } }, Nl = {
  __name: "vue-ui-heatmap",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(R, { expose: fe }) {
    const i = R;
    Ce((l) => ({
      "601200a2": l.tdo
    }));
    const { vue_ui_heatmap: be } = Se(), E = c(() => !!i.dataset && i.dataset.length);
    Ne(i.dataset) && ge({
      componentName: "VueUiHeatmap",
      type: "dataset"
    });
    const N = p(le()), j = p(null), me = p(null), W = p(!1), q = p(""), oe = p(void 0), O = p(null), se = p(0), ue = p(null), ne = p(!1), e = c(() => {
      const l = pe({
        userConfig: i.config,
        defaultConfig: be
      });
      let a = {};
      return l.theme ? a = {
        ...pe({
          userConfig: Oe.vue_ui_heatmap[l.theme] || i.config,
          defaultConfig: l
        })
      } : a = l, i.config && Fe(i.config, "style.layout.dataLabels.xAxis.showOnlyAtModulo") ? a.style.layout.dataLabels.xAxis.showOnlyAtModulo = i.config.style.layout.dataLabels.xAxis.showOnlyAtModulo : a.style.layout.dataLabels.xAxis.showOnlyAtModulo = null, a;
    }), { isPrinting: ie, isImaging: re, generatePdf: de, generateImage: ve } = Xe({
      elementId: `heatmap__${N.value}`,
      fileName: e.value.style.title.text || "vue-ui-heatmap"
    }), w = p({
      showTable: e.value.table.show,
      showTooltip: e.value.style.tooltip.show
    }), xe = c(() => e.value.table.responsiveBreakpoint);
    function we() {
      new ResizeObserver((a) => {
        a.forEach((o) => {
          ne.value = o.contentRect.width < xe.value;
        });
      }).observe(ue.value);
    }
    Le(we);
    const M = c(() => Math.max(...i.dataset.flatMap((l) => (l.values || []).length))), _ = c(() => {
      const l = e.value.style.layout.padding.top + e.value.style.layout.padding.bottom + i.dataset.length * e.value.style.layout.cells.height, a = e.value.style.layout.padding.left + e.value.style.layout.padding.right + (M.value < i.dataset.length ? i.dataset.length : M.value) * e.value.style.layout.cells.height, o = l + (e.value.style.legend.show ? e.value.style.legend.position === "right" ? 0 : e.value.style.layout.cells.height * 2 : 0);
      return {
        height: l,
        heightWithLegend: o,
        width: a
      };
    }), G = c(() => e.value.style.legend.position), t = c(() => ({
      top: e.value.style.layout.padding.top,
      left: e.value.style.layout.padding.left,
      right: _.value.width - e.value.style.layout.padding.right - (G.value === "right" && e.value.style.legend.show ? 92 : 0),
      bottom: _.value.height - e.value.style.layout.padding.bottom,
      height: _.value.height - e.value.style.layout.padding.top - e.value.style.layout.padding.bottom,
      width: _.value.width - e.value.style.layout.padding.right - e.value.style.layout.padding.left - (G.value === "right" && e.value.style.legend.show ? 92 : 0)
    })), K = c(() => d.value.height * i.dataset.length), m = c(() => Math.max(...i.dataset.flatMap((l) => l.values))), S = c(() => Math.min(...i.dataset.flatMap((l) => l.values))), z = c(() => {
      const l = i.dataset.flatMap((o) => o.values);
      return l.reduce((o, r) => o + r, 0) / l.length;
    }), d = c(() => ({
      width: t.value.width / M.value,
      height: t.value.width / (M.value < i.dataset.length ? i.dataset.length : M.value)
    })), $ = c(() => {
      const l = e.value.style.layout.dataLabels.yAxis.values.length ? e.value.style.layout.dataLabels.yAxis.values : i.dataset.map((o) => o.name), a = e.value.style.layout.dataLabels.xAxis.values;
      return {
        yLabels: l,
        xLabels: a.slice(0, M.value)
      };
    }), X = c(() => (i.dataset.forEach((l, a) => {
      Ve({
        datasetObject: l,
        requiredAttributes: ["values"]
      }).forEach((o) => {
        ge({
          componentName: "VueUiHeatmap",
          type: "datasetSerieAttribute",
          property: "values",
          index: a
        });
      });
    }), i.dataset.map((l) => ({
      ...l,
      temperatures: (l.values || []).map((a, o) => a >= z.value ? {
        side: "up",
        color: te(e.value.style.layout.cells.colors.cold, e.value.style.layout.cells.colors.hot, S.value, m.value, a),
        ratio: Math.abs(Math.abs(a - z.value) / Math.abs(m.value - z.value)) > 1 ? 1 : Math.abs(Math.abs(a - z.value) / Math.abs(m.value - z.value)),
        value: a,
        yAxisName: l.name,
        xAxisName: $.value.xLabels[o],
        id: `vue-data-ui-heatmap-cell-${le()}`
      } : {
        side: "down",
        ratio: Math.abs(1 - Math.abs(a) / Math.abs(z.value)) > 1 ? 1 : Math.abs(1 - Math.abs(a) / Math.abs(z.value)),
        color: te(e.value.style.layout.cells.colors.cold, e.value.style.layout.cells.colors.hot, S.value, m.value, a),
        value: a,
        yAxisName: l.name,
        xAxisName: $.value.xLabels[o],
        id: `vue-data-ui-heatmap-cell-${le()}`
      })
    })))), C = p(null), F = p(null);
    function _e(l, a, o, r) {
      O.value = { x: o, y: r };
      const { value: v, yAxisName: g, xAxisName: L, id: $e } = l;
      oe.value = $e, C.value = v, F.value = {
        datapoint: l,
        seriesIndex: a,
        series: X.value,
        config: e.value
      }, W.value = !0;
      let J = "";
      const Q = e.value.style.tooltip.customFormat;
      Pe(Q) && Be(() => Q({
        datapoint: l,
        seriesIndex: a,
        series: X.value,
        config: e.value
      })) ? q.value = Q({
        datapoint: l,
        seriesIndex: a,
        series: X.value,
        config: e.value
      }) : (J += `<div>${g} ${L ? `${L}` : ""}</div>`, J += `<div style="margin-top:6px;padding-top:6px;border-top:1px solid ${e.value.style.tooltip.borderColor};font-weight:bold;display:flex;flex-direction:row;gap:12px;align-items:center;justify-content:center"><span style="color:${te(e.value.style.layout.cells.colors.cold, e.value.style.layout.cells.colors.hot, S.value, m.value, v)}">⬤</span><span>${isNaN(v) ? "-" : Y(
        e.value.style.layout.cells.value.formatter,
        v,
        B({
          p: e.value.style.layout.dataLabels.prefix,
          v,
          s: e.value.style.layout.dataLabels.suffix,
          r: e.value.style.tooltip.roundingValue
        }),
        { datapoint: l, seriesIndex: a }
      )}</span></div>`, q.value = `<div style="font-size:${e.value.style.tooltip.fontSize}px">${J}</div>`);
    }
    const V = c(() => t.value.top + K.value * (1 - C.value / m.value)), I = c(() => t.value.left + (_.value.width - t.value.left - e.value.style.layout.padding.right) * (C.value / m.value));
    c(() => {
      const l = i.dataset.map((o) => ({
        name: o.name
      })), a = i.dataset.map((o) => o.values);
      return { head: l, body: a };
    });
    function ye() {
      Me(() => {
        const l = ["", ...i.dataset.map((v, g) => v.name)], a = [];
        for (let v = 0; v < $.value.xLabels.length; v += 1) {
          const g = [$.value.xLabels[v]];
          for (let L = 0; L < i.dataset.length; L += 1)
            g.push([i.dataset[L].values[v]]);
          a.push(g);
        }
        const o = [[e.value.style.title.text], [e.value.style.title.subtitle.text], [[""], [""], [""]]].concat([l]).concat(a), r = Re(o);
        Ee({ csvContent: r, title: e.value.style.title.text || "vue-ui-heatmap" });
      });
    }
    const P = p(!1);
    function ke(l) {
      P.value = l, se.value += 1;
    }
    function ce() {
      w.value.showTable = !w.value.showTable;
    }
    function he() {
      w.value.showTooltip = !w.value.showTooltip;
    }
    return fe({
      generatePdf: de,
      generateCsv: ye,
      generateImage: ve,
      toggleTable: ce,
      toggleTooltip: he
    }), (l, a) => (s(), n("div", {
      ref_key: "heatmapChart",
      ref: j,
      class: D(`vue-ui-heatmap ${P.value ? "vue-data-ui-wrapper-fullscreen" : ""}`),
      style: b(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.title.text ? "" : "padding-top:36px"};background:${e.value.style.backgroundColor}`),
      id: `heatmap__${N.value}`
    }, [
      e.value.style.title.text ? (s(), n("div", {
        key: 0,
        style: b(`width:100%;background:${e.value.style.backgroundColor}`)
      }, [
        Z(Ge, {
          config: {
            title: {
              cy: "heatmap-div-title",
              ...e.value.style.title
            },
            subtitle: {
              cy: "heatmap-div-subtitle",
              ...e.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"])
      ], 4)) : y("", !0),
      e.value.userOptions.show && E.value ? (s(), ee(De, {
        ref_key: "details",
        ref: me,
        key: `user_options_${se.value}`,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        isImaging: h(re),
        isPrinting: h(ie),
        uid: N.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isFullscreen: P.value,
        isTooltip: w.value.showTooltip,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: j.value,
        onToggleFullscreen: ke,
        onGeneratePdf: h(de),
        onGenerateCsv: ye,
        onGenerateImage: h(ve),
        onToggleTable: ce,
        onToggleTooltip: he
      }, Ae({ _: 2 }, [
        l.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: k(() => [
            x(l.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: k(() => [
            x(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: k(() => [
            x(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: k(() => [
            x(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: k(() => [
            x(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: k(({ toggleFullscreen: o, isFullscreen: r }) => [
            x(l.$slots, "optionFullscreen", H(U({ toggleFullscreen: o, isFullscreen: r })), void 0, !0)
          ]),
          key: "5"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isFullscreen", "isTooltip", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : y("", !0),
      E.value ? (s(), n("svg", {
        key: 2,
        xmlns: h(Ie),
        class: D({ "vue-data-ui-fullscreen--on": P.value, "vue-data-ui-fulscreen--off": !P.value }),
        viewBox: `0 0 ${_.value.width} ${_.value.heightWithLegend}`,
        style: b(`max-width:100%;overflow:visible;background:${e.value.style.backgroundColor};color:${e.value.style.color}`)
      }, [
        (s(!0), n(A, null, T(X.value, (o, r) => (s(), n("g", null, [
          (s(!0), n(A, null, T(o.temperatures, (v, g) => (s(), n("g", null, [
            u("rect", {
              x: t.value.left + d.value.width * g + e.value.style.layout.cells.spacing / 2,
              y: t.value.top + d.value.height * r + e.value.style.layout.cells.spacing / 2,
              width: d.value.width - e.value.style.layout.cells.spacing,
              height: d.value.height - e.value.style.layout.cells.spacing,
              fill: e.value.style.layout.cells.colors.underlayer,
              stroke: e.value.style.backgroundColor,
              "stroke-width": e.value.style.layout.cells.spacing
            }, null, 8, Je),
            u("rect", {
              x: t.value.left + d.value.width * g + e.value.style.layout.cells.spacing / 2,
              y: t.value.top + d.value.height * r + e.value.style.layout.cells.spacing / 2,
              width: d.value.width - e.value.style.layout.cells.spacing,
              height: d.value.height - e.value.style.layout.cells.spacing,
              fill: v.color,
              stroke: e.value.style.backgroundColor,
              "stroke-width": e.value.style.layout.cells.spacing
            }, null, 8, Qe),
            e.value.style.layout.cells.value.show ? (s(), n("text", {
              key: 0,
              "text-anchor": "middle",
              "font-size": e.value.style.layout.cells.value.fontSize,
              "font-weight": e.value.style.layout.cells.value.bold ? "bold" : "normal",
              fill: h(ae)(v.color),
              x: t.value.left + d.value.width * g + d.value.width / 2,
              y: t.value.top + d.value.height * r + d.value.height / 2 + e.value.style.layout.cells.value.fontSize / 3
            }, f(h(Y)(
              e.value.style.layout.cells.value.formatter,
              v.value,
              h(B)({
                p: e.value.style.layout.dataLabels.prefix,
                v: v.value,
                s: e.value.style.layout.dataLabels.suffix,
                r: e.value.style.layout.cells.value.roundingValue
              }),
              { datapoint: v }
            )), 9, Ze)) : y("", !0)
          ]))), 256)),
          (s(!0), n(A, null, T(o.temperatures, (v, g) => (s(), n("g", null, [
            u("rect", {
              x: t.value.left + d.value.width * g,
              y: t.value.top + d.value.height * r,
              width: d.value.width,
              height: d.value.height,
              fill: "transparent",
              stroke: "none",
              onMouseover: (L) => _e(v, r, t.value.left + d.value.width * g, t.value.top + d.value.height * r),
              onMouseout: a[0] || (a[0] = (L) => {
                W.value = !1, oe.value = void 0, C.value = null, O.value = null;
              })
            }, null, 40, el)
          ]))), 256)),
          e.value.style.layout.dataLabels.yAxis.show ? (s(), n("g", ll, [
            u("text", {
              "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
              fill: e.value.style.layout.dataLabels.yAxis.color,
              x: t.value.left + e.value.style.layout.dataLabels.yAxis.offsetX - 6,
              y: t.value.top + d.value.height * r + d.value.height / 2 + e.value.style.layout.dataLabels.yAxis.fontSize / 3 + e.value.style.layout.dataLabels.yAxis.offsetY,
              "text-anchor": "end",
              "font-weight": e.value.style.layout.dataLabels.yAxis.bold ? "bold" : "normal"
            }, f($.value.yLabels[r]), 9, tl)
          ])) : y("", !0)
        ]))), 256)),
        e.value.style.layout.dataLabels.xAxis.show ? (s(), n("g", al, [
          (s(!0), n(A, null, T($.value.xLabels, (o, r) => (s(), n(A, null, [
            !e.value.style.layout.dataLabels.xAxis.showOnlyAtModulo || e.value.style.layout.dataLabels.xAxis.showOnlyAtModulo && r % e.value.style.layout.dataLabels.xAxis.showOnlyAtModulo === 0 ? (s(), n("text", {
              key: 0,
              "text-anchor": e.value.style.layout.dataLabels.xAxis.rotation === 0 ? "middle" : e.value.style.layout.dataLabels.xAxis.rotation < 0 ? "start" : "end",
              "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
              fill: e.value.style.layout.dataLabels.xAxis.color,
              "font-weight": e.value.style.layout.dataLabels.xAxis.bold ? "bold" : "normal",
              transform: `translate(${t.value.left + d.value.width / 2 + t.value.width / $.value.xLabels.length * r + e.value.style.layout.dataLabels.xAxis.offsetX}, ${t.value.top + e.value.style.layout.dataLabels.xAxis.offsetY - 6}), rotate(${e.value.style.layout.dataLabels.xAxis.rotation})`
            }, f(o), 9, ol)) : y("", !0)
          ], 64))), 256))
        ])) : y("", !0),
        O.value ? (s(), n("g", sl, [
          u("rect", {
            style: { "pointer-events": "none" },
            x: O.value.x - e.value.style.layout.cells.selected.border / 2 + e.value.style.layout.cells.spacing,
            y: O.value.y - e.value.style.layout.cells.selected.border / 2 + e.value.style.layout.cells.spacing,
            width: d.value.width - e.value.style.layout.cells.spacing + e.value.style.layout.cells.selected.border - e.value.style.layout.cells.spacing,
            height: d.value.height - e.value.style.layout.cells.spacing + e.value.style.layout.cells.selected.border - e.value.style.layout.cells.spacing,
            fill: "transparent",
            stroke: e.value.style.layout.cells.selected.color,
            "stroke-width": e.value.style.layout.cells.selected.border,
            rx: 1
          }, null, 8, ul)
        ])) : y("", !0),
        e.value.style.legend.show && G.value === "right" ? (s(), n("g", nl, [
          u("defs", null, [
            u("linearGradient", {
              id: `colorScaleVertical_${N.value}`,
              x2: "0%",
              y2: "100%"
            }, [
              u("stop", {
                offset: "0%",
                "stop-color": e.value.style.layout.cells.colors.hot
              }, null, 8, rl),
              u("stop", {
                offset: "100%",
                "stop-color": e.value.style.layout.cells.colors.cold
              }, null, 8, dl)
            ], 8, il)
          ]),
          u("text", {
            x: t.value.right + 36 + 18,
            y: t.value.top - e.value.style.legend.fontSize * 1.5,
            "text-anchor": "middle",
            "font-size": e.value.style.legend.fontSize * 2,
            fill: e.value.style.legend.color
          }, f(h(Y)(
            e.value.style.layout.cells.value.formatter,
            m.value,
            h(B)({
              p: e.value.style.layout.dataLabels.prefix,
              v: m.value,
              s: e.value.style.layout.dataLabels.suffix,
              r: e.value.style.legend.roundingValue
            })
          )), 9, vl),
          u("rect", {
            x: t.value.right + 36,
            y: t.value.top,
            width: 36,
            height: K.value,
            rx: e.value.style.legend.scaleBorderRadius,
            fill: `url(#colorScaleVertical_${N.value})`
          }, null, 8, yl),
          u("text", {
            x: t.value.right + 36 + 18,
            y: t.value.top + K.value + e.value.style.legend.fontSize * 2.5,
            "text-anchor": "middle",
            "font-size": e.value.style.legend.fontSize * 2,
            fill: e.value.style.legend.color
          }, f(h(Y)(
            e.value.style.layout.cells.value.formatter,
            S.value,
            h(B)({
              p: e.value.style.layout.dataLabels.prefix,
              v: S.value,
              s: e.value.style.layout.dataLabels.suffix,
              r: e.value.style.legend.roundingValue
            })
          )), 9, cl),
          C.value !== null ? (s(), n("line", {
            key: 0,
            stroke: h(ae)(F.value.datapoint.color),
            "stroke-width": "2",
            x1: t.value.right + 36,
            x2: t.value.right + 72,
            y1: V.value,
            y2: V.value
          }, null, 8, hl)) : y("", !0),
          C.value !== null ? (s(), n("path", {
            key: 1,
            fill: e.value.style.color,
            stroke: "none",
            d: `M ${t.value.right + 36},${V.value} ${t.value.right + 26},${V.value - 8} ${t.value.right + 26},${V.value + 8}z`
          }, null, 8, gl)) : y("", !0)
        ])) : y("", !0),
        e.value.style.legend.show && G.value === "bottom" ? (s(), n("g", pl, [
          u("defs", null, [
            u("linearGradient", fl, [
              u("stop", {
                offset: "0%",
                "stop-color": e.value.style.layout.cells.colors.cold
              }, null, 8, bl),
              u("stop", {
                offset: "100%",
                "stop-color": e.value.style.layout.cells.colors.hot
              }, null, 8, ml)
            ])
          ]),
          u("rect", {
            x: t.value.left,
            y: t.value.bottom + e.value.style.layout.cells.height,
            width: _.value.width - t.value.left - e.value.style.layout.padding.right,
            height: e.value.style.layout.cells.height,
            rx: e.value.style.legend.scaleBorderRadius > e.value.style.layout.cells.height / 2 ? e.value.style.layout.cells.height / 2 : e.value.style.legend.scaleBorderRadius,
            fill: "url(#colorScaleHorizontal)"
          }, null, 8, xl),
          u("text", {
            x: t.value.left,
            y: t.value.bottom + e.value.style.layout.cells.height * 2 + e.value.style.legend.fontSize * 2,
            "text-anchor": "start",
            "font-size": e.value.style.legend.fontSize * 2,
            fill: e.value.style.legend.color
          }, f(Number(S.value.toFixed(e.value.style.legend.roundingValue)).toLocaleString()), 9, wl),
          u("text", {
            x: t.value.right,
            y: t.value.bottom + e.value.style.layout.cells.height * 2 + e.value.style.legend.fontSize * 2,
            "text-anchor": "end",
            "font-size": e.value.style.legend.fontSize * 2,
            fill: e.value.style.legend.color
          }, f(Number(m.value.toFixed(e.value.style.legend.roundingValue)).toLocaleString()), 9, _l),
          C.value !== null ? (s(), n("line", {
            key: 0,
            stroke: h(ae)(F.value.datapoint.color),
            "stroke-width": "2",
            x1: I.value,
            x2: I.value,
            y1: t.value.bottom + e.value.style.layout.cells.height,
            y2: t.value.bottom + e.value.style.layout.cells.height * 2
          }, null, 8, kl)) : y("", !0),
          C.value !== null ? (s(), n("path", {
            key: 1,
            fill: e.value.style.color,
            stroke: "none",
            d: `M ${I.value},${t.value.bottom + e.value.style.layout.cells.height} ${I.value - 12},${t.value.bottom + e.value.style.layout.cells.height - 20} ${I.value + 12},${t.value.bottom + e.value.style.layout.cells.height - 20}z`
          }, null, 8, $l)) : y("", !0)
        ])) : y("", !0),
        x(l.$slots, "svg", { svg: _.value }, void 0, !0)
      ], 14, Ke)) : y("", !0),
      l.$slots.watermark ? (s(), n("div", Cl, [
        x(l.$slots, "watermark", H(U({ isPrinting: h(ie) || h(re) })), void 0, !0)
      ])) : y("", !0),
      E.value ? y("", !0) : (s(), ee(Ue, {
        key: 4,
        config: {
          type: "heatmap",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            heatmap: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      Z(He, {
        show: w.value.showTooltip && W.value,
        backgroundColor: e.value.style.tooltip.backgroundColor,
        color: e.value.style.tooltip.color,
        borderRadius: e.value.style.tooltip.borderRadius,
        borderColor: e.value.style.tooltip.borderColor,
        borderWidth: e.value.style.tooltip.borderWidth,
        fontSize: e.value.style.tooltip.fontSize,
        backgroundOpacity: e.value.style.tooltip.backgroundOpacity,
        position: e.value.style.tooltip.position,
        offsetY: e.value.style.tooltip.offsetY,
        parent: j.value,
        content: q.value,
        isCustom: e.value.style.tooltip.customFormat && typeof e.value.style.tooltip.customFormat == "function"
      }, {
        "tooltip-before": k(() => [
          x(l.$slots, "tooltip-before", H(U({ ...F.value })), void 0, !0)
        ]),
        "tooltip-after": k(() => [
          x(l.$slots, "tooltip-after", H(U({ ...F.value })), void 0, !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      E.value ? (s(), ee(je, {
        key: 5,
        hideDetails: "",
        config: {
          open: w.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          },
          head: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          }
        }
      }, {
        content: k(() => [
          u("div", {
            ref_key: "tableContainer",
            ref: ue,
            class: "vue-ui-heatmap-table"
          }, [
            u("div", {
              style: "width:100%;overflow-x:auto;padding-top:36px;position:relative",
              class: D({ "vue-ui-responsive": ne.value })
            }, [
              u("div", {
                role: "button",
                tabindex: "0",
                style: b(`width:32px; position: absolute; top: 0; left:4px; padding: 0 0px; display: flex; align-items:center;justify-content:center;height: 36px; width: 32px; cursor:pointer; background:${e.value.table.th.backgroundColor};`),
                onClick: a[1] || (a[1] = (o) => w.value.showTable = !1),
                onKeypress: a[2] || (a[2] = ze((o) => w.value.showTable = !1, ["enter"]))
              }, [
                Z(Ye, {
                  name: "close",
                  stroke: e.value.table.th.color,
                  "stroke-width": 2
                }, null, 8, ["stroke"])
              ], 36),
              u("table", Ll, [
                u("caption", {
                  style: b(`backgroundColor:${e.value.table.th.backgroundColor};color:${e.value.table.th.color};outline:${e.value.table.th.outline}`)
                }, [
                  Te(f(e.value.style.title.text) + " ", 1),
                  e.value.style.title.subtitle.text ? (s(), n("span", Al, f(e.value.style.title.subtitle.text), 1)) : y("", !0)
                ], 4),
                u("thead", null, [
                  u("tr", {
                    role: "row",
                    style: b(`background:${e.value.table.th.backgroundColor};color:${e.value.table.th.color}`)
                  }, [
                    u("th", {
                      style: b(`outline:${e.value.table.th.outline};padding-right:6px`)
                    }, null, 4),
                    (s(!0), n(A, null, T(R.dataset, (o, r) => (s(), n("th", {
                      align: "right",
                      style: b(`outline:${e.value.table.th.outline};padding-right:6px`)
                    }, f(o.name), 5))), 256))
                  ], 4)
                ]),
                u("tbody", null, [
                  (s(!0), n(A, null, T($.value.xLabels, (o, r) => (s(), n("tr", {
                    role: "row",
                    class: D({ "vue-ui-data-table__tbody__row": !0, "vue-ui-data-table__tbody__row-even": r % 2 === 0, "vue-ui-data-table__tbody__row-odd": r % 2 !== 0 }),
                    style: b(`background:${e.value.table.td.backgroundColor};color:${e.value.table.td.color}`)
                  }, [
                    u("td", {
                      "data-cell": e.value.table.colNames.xAxis,
                      class: "vue-ui-data-table__tbody__td",
                      style: b(`outline:${e.value.table.td.outline}`)
                    }, [
                      u("div", Tl, f(o), 1)
                    ], 12, zl),
                    (s(!0), n(A, null, T(R.dataset, (v, g) => (s(), n("td", {
                      class: "vue-ui-data-table__tbody__td",
                      "data-cell": R.dataset[g].name,
                      style: b(`outline:${e.value.table.td.outline}`)
                    }, [
                      u("div", Sl, f(isNaN(v.values[r]) ? "-" : h(B)({ p: e.value.style.layout.dataLabels.prefix, v: v.values[r], s: e.value.style.layout.dataLabels.suffix, r: e.value.table.td.roundingValue })), 1)
                    ], 12, Ml))), 256))
                  ], 6))), 256))
                ])
              ])
            ], 2)
          ], 512)
        ]),
        _: 1
      }, 8, ["config"])) : y("", !0)
    ], 14, qe));
  }
}, Dl = /* @__PURE__ */ We(Nl, [["__scopeId", "data-v-7aca40a7"]]);
export {
  Dl as default
};
