import { computed as b, ref as k, onMounted as Ee, onBeforeUnmount as Ve, openBlock as s, createElementBlock as r, normalizeClass as Ae, normalizeStyle as D, createVNode as le, createCommentVNode as c, createBlock as J, unref as d, createSlots as Ge, withCtx as w, renderSlot as A, normalizeProps as ae, guardReactiveProps as oe, createElementVNode as v, Fragment as N, renderList as W, toDisplayString as $, createTextVNode as Re, nextTick as qe } from "vue";
import { u as Ue, c as He, t as Je, a as Ke, p as R, o as Qe, e as ce, b as Ze, g as Te, N as Be, X as et, P as tt, v as de, i as Y, f as F, w as lt, x as at, q as ot, r as st } from "./index-CpHoINpJ.js";
import { t as ut, u as rt } from "./useResponsive-NZB-WLRF.js";
import { _ as it } from "./Title-xP0rAF4q.js";
import { u as nt, U as yt } from "./usePrinter-BHy-mfVg.js";
import { _ as vt } from "./Tooltip-DfBa_7Ur.js";
import { L as ct } from "./Legend-DB6v_LvZ.js";
import { _ as Ne } from "./Shape-B_f1_6Ob.js";
import { D as dt } from "./DataTable-1VV0us-8.js";
import ht from "./vue-ui-skeleton-DuM6yey6.js";
import pt from "./vue-ui-accordion-BZloYo0L.js";
import { u as Pe } from "./useNestedProp-BOjw3Yqn.js";
import { _ as ft } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const gt = ["id"], xt = ["xmlns", "viewBox"], mt = { key: 0 }, bt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], kt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], _t = { key: 1 }, wt = ["points", "fill", "stroke-width", "stroke-dasharray", "stroke"], $t = { key: 0 }, Mt = ["cx", "cy", "r", "fill", "stroke", "stroke-width", "onMouseover"], Ct = { key: 1 }, zt = { key: 2 }, St = ["id"], Lt = ["stop-color"], At = ["stop-color"], Tt = ["id"], Bt = ["stop-color"], Nt = ["stop-color"], Pt = ["x", "y", "width", "height", "fill", "stroke", "stroke-width", "rx"], Wt = ["x", "y", "height", "width", "fill", "stroke", "stroke-width", "rx"], Ft = { key: 0 }, Ot = ["d", "stroke", "stroke-width"], Xt = ["d", "stroke", "stroke-width"], It = ["d", "stroke", "stroke-width"], Dt = ["d", "stroke", "stroke-width"], Yt = {
  key: 3,
  style: { "pointer-events": "none !important" }
}, jt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], Et = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], Vt = ["x", "y", "font-size", "fill", "font-weight", "text-anchor"], Gt = ["x", "y", "font-size", "fill", "font-weight"], Rt = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], qt = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], Ut = ["x", "y", "font-size", "fill", "font-weight", "text-anchor"], Ht = { key: 4 }, Jt = ["x", "y", "font-size", "fill"], Kt = ["x", "y", "font-size", "fill"], Qt = ["id", "transform", "font-size", "font-weight", "fill"], Zt = { key: 5 }, el = ["x", "y", "font-size", "fill"], tl = ["x", "y", "font-size", "fill"], ll = ["font-size", "font-weight", "fill", "x", "y"], al = ["id"], ol = ["x", "y", "width", "height"], sl = { key: 6 }, ul = ["x1", "x2", "y1", "y2", "stroke-dasharray", "stroke", "stroke-width", "clip-path"], rl = ["x", "y", "fill", "font-size", "font-weight"], il = {
  key: 3,
  class: "vue-data-ui-watermark"
}, nl = ["onClick"], yl = {
  key: 0,
  style: { width: "100%", display: "flex", "align-items": "center", "justify-content": "center" }
}, vl = {
  viewBox: "0 0 20 20",
  height: "20",
  width: "20",
  style: { overflow: "hidden", background: "transparent" }
}, cl = { key: 0 }, dl = ["innerHTML"], hl = {
  __name: "vue-ui-scatter",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(We, { expose: Fe }) {
    const O = We, { vue_ui_scatter: Oe } = Ue(), K = b(() => !!O.dataset && O.dataset.length), M = k(He()), Xe = k(null), se = k(!1), ue = k(""), he = k(0), U = k(null), pe = k(null), fe = k(null), e = b(() => {
      const l = Pe({
        userConfig: O.config,
        defaultConfig: Oe
      });
      return l.theme ? {
        ...Pe({
          userConfig: Je.vue_ui_scatter[l.theme] || O.config,
          defaultConfig: l
        }),
        customPalette: Ke[l.theme] || R
      } : l;
    }), Q = k(null);
    Ee(() => {
      if (Qe(O.dataset) && ce({
        componentName: "VueUiScatter",
        type: "dataset"
      }), e.value.responsive) {
        const l = ut(() => {
          const { width: i, height: t } = rt({
            chart: U.value,
            title: e.value.style.title.text ? pe.value : null,
            legend: e.value.style.legend.show ? fe.value : null
          });
          C.value.width = i, C.value.height = t;
        });
        Q.value = new ResizeObserver(l), Q.value.observe(U.value.parentNode);
      }
    }), Ve(() => {
      Q.value && Q.value.disconnect();
    });
    const { isPrinting: ge, isImaging: xe, generatePdf: me, generateImage: be } = nt({
      elementId: `vue-ui-scatter_${M.value}`,
      fileName: e.value.style.title.text || "vue-ui-scatter"
    }), ke = b(() => Ze(e.value.customPalette)), X = k({
      showTable: e.value.table.show,
      showTooltip: e.value.style.tooltip.show
    }), C = k({
      height: e.value.style.layout.height,
      width: e.value.style.layout.width
    }), Z = b(() => e.value.style.layout.marginalBars.show ? e.value.style.layout.marginalBars.size + e.value.style.layout.marginalBars.offset : 0), u = b(() => ({
      top: e.value.style.layout.padding.top + Z.value,
      right: C.value.width - e.value.style.layout.padding.right - Z.value,
      bottom: C.value.height - e.value.style.layout.padding.bottom,
      left: e.value.style.layout.padding.left,
      height: C.value.height - e.value.style.layout.padding.top - e.value.style.layout.padding.bottom - Z.value,
      width: C.value.width - e.value.style.layout.padding.left - e.value.style.layout.padding.right - Z.value
    })), h = b(() => {
      O.dataset.forEach((a, n) => {
        Te({
          datasetObject: a,
          requiredAttributes: ["values"]
        }).forEach((x) => {
          ce({
            componentName: "VueUiScatter",
            type: "datasetSerieAttribute",
            property: x,
            index: n
          });
        }), a.values && a.values.forEach((x, E) => {
          Te({
            datasetObject: x,
            requiredAttributes: ["x", "y"]
          }).forEach((q) => {
            ce({
              componentName: "VueUiScatter",
              type: "datasetSerieAttribute",
              property: `values.${q}`,
              index: `${n} - ${E}`
            });
          });
        });
      });
      const l = Math.min(...j.value.filter((a) => !g.value.includes(a.id)).flatMap((a) => a.values.map((n) => n.x))), i = Math.max(...j.value.filter((a) => !g.value.includes(a.id)).flatMap((a) => a.values.map((n) => n.x))), t = Math.min(...j.value.filter((a) => !g.value.includes(a.id)).flatMap((a) => a.values.map((n) => n.y))), o = Math.max(...j.value.filter((a) => !g.value.includes(a.id)).flatMap((a) => a.values.map((n) => n.y)));
      return { xMin: l >= 0 ? 0 : l, xMax: i, yMin: t >= 0 ? 0 : t, yMax: o };
    }), p = b(() => ({
      x: u.value.left + Math.abs(h.value.xMin) / (h.value.xMax + Math.abs(h.value.xMin)) * u.value.width,
      y: u.value.bottom - Math.abs(h.value.yMin) / (h.value.yMax + Math.abs(h.value.yMin)) * u.value.height
    })), j = b(() => O.dataset.map((l, i) => {
      const t = `cluster_${M.value}_${i}`;
      return {
        ...l,
        id: t,
        color: l.color ? l.color : ke.value[i] || R[i] || R[i % R.length],
        opacity: g.value.includes(t) ? 0.5 : 1,
        shape: l.shape ?? "circle",
        segregate: () => Ce(t),
        isSegregated: g.value.includes(t)
      };
    })), Ie = b(() => ({
      cy: "scatter-div-legend",
      backgroundColor: e.value.style.legend.backgroundColor,
      color: e.value.style.legend.color,
      fontSize: e.value.style.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.legend.bold ? "bold" : ""
    })), re = b(() => j.value.map((l, i) => ({
      ...l,
      plots: l.values.map((t) => ({
        x: u.value.left + (t.x + Math.abs(h.value.xMin)) / (h.value.xMax + Math.abs(h.value.xMin)) * u.value.width,
        y: u.value.bottom - (t.y + Math.abs(h.value.yMin)) / (h.value.yMax + Math.abs(h.value.yMin)) * u.value.height,
        v: {
          ...t,
          name: t.name || ""
        },
        clusterName: l.name,
        color: l.color ? l.color : ke.value[i] || R[i] || R[i % R.length],
        id: `plot_${M.value}_${Math.random()}`,
        weight: t.weight ?? e.value.style.layout.plots.radius
      }))
    })).filter((l) => !g.value.includes(l.id))), z = b(() => re.value.map((l) => {
      const i = l.plots.reduce((f, V) => f + V.x, 0) / l.plots.length, t = l.plots.reduce((f, V) => f + V.y, 0) / l.plots.length;
      let o = 0, a = 0, n = 0;
      for (const f of l.plots)
        o += (f.x - i) * (f.y - t), a += (f.x - i) ** 2, n += (f.y - t) ** 2;
      const x = o / Math.sqrt(a * n), E = x * (Math.sqrt(n) / Math.sqrt(a)), q = t - E * i, B = {
        x1: u.value.left,
        x2: u.value.right,
        y1: E * u.value.left + q,
        y2: E * u.value.right + q,
        coefficient: x
      }, _ = (B.y2 - B.y1) / (B.x2 - B.x1), L = B.y1 - _ * B.x1, P = Math.min(C.value.width - e.value.style.layout.padding.right, Math.max(e.value.style.layout.padding.left, (u.value.top - L) / _)), te = {
        x: P,
        y: _ * P + L <= e.value.style.layout.padding.top ? u.value.top : _ * P + L
      };
      return {
        ...l,
        correlation: B,
        label: te,
        plots: l.plots.map((f) => {
          const V = (f.x + _ * f.y - _ * L) / (1 + Math.pow(_, 2)), ne = (_ * f.x + Math.pow(_, 2) * f.y + L) / (1 + Math.pow(_, 2)), m = Math.sqrt(Math.pow(f.x - V, 2) + Math.pow(f.y - ne, 2));
          return {
            ...f,
            deviation: m,
            shape: l.shape,
            color: l.color
          };
        })
      };
    })), _e = b(() => Math.max(...z.value.flatMap((l) => l.plots.map((i) => Math.abs(i.deviation)))));
    function De() {
      return z.value;
    }
    function we(l, i) {
      const t = Array.isArray(l) ? l.flatMap((m) => m.plots.map((G) => ({
        x: G.x,
        y: G.y
      }))) : l.plots.map((m) => ({
        x: m.x,
        y: m.y
      }));
      let o = 1 / 0, a = -1 / 0, n = 1 / 0, x = -1 / 0;
      t.forEach(({ x: m, y: G }) => {
        o = Math.min(o, m), a = Math.max(a, m), n = Math.min(n, G), x = Math.max(x, G);
      });
      const E = a - o, q = x - n, B = E / i, _ = q / i, L = Array(i).fill(0), P = Array(i).fill(0);
      t.forEach(({ x: m, y: G }) => {
        const ye = Math.floor((m - o) / B), ve = Math.floor((G - n) / _);
        L[ye] || (L[ye] = 0), P[ve] || (P[ve] = 0), L[ye] += 1, P[ve] += 1;
      });
      const te = [], f = [];
      for (let m = 0; m < i; m += 1)
        te.push(o + (m + 0.5) * B), f.push(n + (m + 0.5) * _);
      const V = Math.max(...L), ne = Math.max(...P);
      return { x: L, y: P, avgX: te, avgY: f, maxX: V, maxY: ne };
    }
    const I = b(() => e.value.style.layout.marginalBars.tranches), S = b(() => we(re.value, I.value)), Ye = b(() => {
      const l = u.value.top - e.value.style.layout.marginalBars.offset, i = u.value.right + e.value.style.layout.marginalBars.offset;
      return re.value.map((t) => {
        const o = we(t, I.value);
        return {
          coords: o,
          dX: Be(o.avgX.map((a, n) => ({
            x: a,
            y: l - o.x[n] / o.maxX * e.value.style.layout.marginalBars.size
          }))),
          dY: Be(o.avgY.map((a, n) => ({
            y: a,
            x: i + e.value.style.layout.marginalBars.size * o.y[n] / o.maxY
          }))),
          color: t.color,
          id: t.id
        };
      });
    }), T = k(void 0), y = k(null), ie = k(null);
    function $e(l, i) {
      T.value = l.id, y.value = l;
      let t = "";
      ie.value = {
        datapoint: l,
        seriesIndex: i,
        series: z.value,
        config: e.value
      };
      const o = e.value.style.tooltip.customFormat;
      lt(o) && at(() => o({
        datapoint: l,
        seriesIndex: i,
        series: z.value,
        config: e.value
      })) ? ue.value = o({
        datapoint: l,
        seriesIndex: i,
        series: z.value,
        config: e.value
      }) : (l.clusterName && (t += `<div style="display:flex;gap:3px;align-items:center">${l.clusterName}</div>`), l.v.name && (t += `<div>${l.v.name}</div>`), t += `<div style="text-align:left;margin-top:6px;padding-top:6px;border-top:1px solid ${e.value.style.tooltip.borderColor}">`, t += `<div>${e.value.style.layout.dataLabels.xAxis.name}: <b>${isNaN(l.v.x) ? "-" : Y(
        e.value.style.layout.plots.selectors.labels.x.formatter,
        l.v.x,
        F({
          p: e.value.style.tooltip.prefix,
          v: l.v.x,
          s: e.value.style.tooltip.suffix,
          r: e.value.style.tooltip.roundingValue
        }),
        { datapoint: l, seriesIndex: i }
      )}</b></div>`, t += `<div>${e.value.style.layout.dataLabels.yAxis.name}: <b>${isNaN(l.v.y) ? "-" : Y(
        e.value.style.layout.plots.selectors.labels.y.formatter,
        l.v.y,
        F({
          p: e.value.style.tooltip.prefix,
          v: l.v.y,
          s: e.value.style.tooltip.suffix,
          r: e.value.style.tooltip.roundingValue
        }),
        { datapoint: l, seriesIndex: i }
      )}</b></div>`, t += `${e.value.style.layout.plots.deviation.translation}: <b>${F({
        v: l.deviation,
        r: e.value.style.layout.plots.deviation.roundingValue
      })}</b>`, t += "</div>", ue.value = `<div>${t}</div>`), se.value = !0;
    }
    function Me() {
      se.value = !1, T.value = void 0, y.value = null;
    }
    const g = k([]);
    function Ce(l) {
      g.value.includes(l) ? g.value = g.value.filter((i) => i !== l) : g.value.length < O.dataset.length - 1 && g.value.push(l);
    }
    function ze() {
      qe(() => {
        const l = ["", e.value.table.translations.correlationCoefficient, e.value.table.translations.nbrPlots, `${e.value.style.layout.dataLabels.xAxis.name} ${e.value.table.translations.average}`, `${e.value.style.layout.dataLabels.yAxis.name} ${e.value.table.translations.average}`], i = z.value.map((a) => [
          a.name,
          a.correlation.coefficient,
          a.plots.length,
          a.plots.map((n) => n.v.x).reduce((n, x) => n + x, 0) / a.plots.length,
          a.plots.map((n) => n.v.y).reduce((n, x) => n + x, 0) / a.plots.length
        ]), t = [[e.value.style.title.text], [e.value.style.title.subtitle.text], [[""], [""], [""]]].concat([l]).concat(i), o = ot(t);
        st({ csvContent: o, title: e.value.style.title.text || "vue-ui-heatmap" });
      });
    }
    const ee = b(() => {
      const l = [
        e.value.table.translations.series,
        e.value.table.translations.correlationCoefficient,
        e.value.table.translations.nbrPlots,
        `${e.value.style.layout.dataLabels.xAxis.name} ${e.value.table.translations.average}`,
        `${e.value.style.layout.dataLabels.yAxis.name} ${e.value.table.translations.average}`
      ], i = z.value.map((o) => [
        {
          shape: o.shape,
          content: o.name,
          color: o.color
        },
        Number((o.correlation.coefficient ?? 0).toFixed(e.value.table.td.roundingValue)).toLocaleString(),
        o.plots.length.toLocaleString(),
        Number((o.plots.map((a) => a.v.x ?? 0).reduce((a, n) => a + n, 0) / o.plots.length).toFixed(e.value.table.td.roundingAverage)).toLocaleString(),
        Number((o.plots.map((a) => a.v.y ?? 0).reduce((a, n) => a + n, 0) / o.plots.length).toFixed(e.value.table.td.roundingAverage)).toLocaleString()
      ]), t = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return { head: l, body: i, config: t, colNames: l };
    }), H = k(!1);
    function je(l) {
      H.value = l, he.value += 1;
    }
    function Se() {
      X.value.showTable = !X.value.showTable;
    }
    function Le() {
      X.value.showTooltip = !X.value.showTooltip;
    }
    return Fe({
      getData: De,
      generatePdf: me,
      generateCsv: ze,
      generateImage: be,
      toggleTable: Se,
      toggleTooltip: Le
    }), (l, i) => (s(), r("div", {
      class: Ae(`vue-ui-scatter ${H.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      ref_key: "scatterChart",
      ref: U,
      id: `vue-ui-scatter_${M.value}`,
      style: D(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;${e.value.style.title.text ? "" : "padding-top:36px"};background:${e.value.style.backgroundColor};${e.value.responsive ? "height: 100%" : ""}`)
    }, [
      e.value.style.title.text ? (s(), r("div", {
        key: 0,
        ref_key: "chartTitle",
        ref: pe,
        style: D(`width:100%;background:${e.value.style.backgroundColor}`)
      }, [
        le(it, {
          config: {
            title: {
              cy: "scatter-div-title",
              ...e.value.style.title
            },
            subtitle: {
              cy: "scatter-div-subtitle",
              ...e.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"])
      ], 4)) : c("", !0),
      e.value.userOptions.show && K.value ? (s(), J(yt, {
        ref_key: "details",
        ref: Xe,
        key: `user_options_${he.value}`,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        isImaging: d(xe),
        isPrinting: d(ge),
        uid: M.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isTooltip: X.value.showTooltip,
        isFullscreen: H.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: U.value,
        onToggleFullscreen: je,
        onGeneratePdf: d(me),
        onGenerateCsv: ze,
        onGenerateImage: d(be),
        onToggleTable: Se,
        onToggleTooltip: Le
      }, Ge({ _: 2 }, [
        l.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: w(() => [
            A(l.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        l.$slots.optionPdf ? {
          name: "optionPdf",
          fn: w(() => [
            A(l.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        l.$slots.optionCsv ? {
          name: "optionCsv",
          fn: w(() => [
            A(l.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        l.$slots.optionImg ? {
          name: "optionImg",
          fn: w(() => [
            A(l.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        l.$slots.optionTable ? {
          name: "optionTable",
          fn: w(() => [
            A(l.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        l.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: w(({ toggleFullscreen: t, isFullscreen: o }) => [
            A(l.$slots, "optionFullscreen", ae(oe({ toggleFullscreen: t, isFullscreen: o })), void 0, !0)
          ]),
          key: "5"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isTooltip", "isFullscreen", "titles", "chartElement", "onGeneratePdf", "onGenerateImage"])) : c("", !0),
      K.value ? (s(), r("svg", {
        key: 2,
        xmlns: d(et),
        class: Ae({ "vue-data-ui-fullscreen--on": H.value, "vue-data-ui-fulscreen--off": !H.value }),
        viewBox: `0 0 ${C.value.width <= 0 ? 10 : C.value.width} ${C.value.height <= 0 ? 10 : C.value.height}`,
        style: D(`max-width:100%;overflow:visible;background:${e.value.style.backgroundColor};color:${e.value.style.color}`)
      }, [
        e.value.style.layout.axis.show ? (s(), r("g", mt, [
          v("line", {
            x1: p.value.x,
            x2: p.value.x,
            y1: u.value.top,
            y2: u.value.bottom,
            stroke: e.value.style.layout.axis.stroke,
            "stroke-width": e.value.style.layout.axis.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, bt),
          v("line", {
            x1: u.value.left,
            x2: u.value.right,
            y1: p.value.y,
            y2: p.value.y,
            stroke: e.value.style.layout.axis.stroke,
            "stroke-width": e.value.style.layout.axis.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, kt)
        ])) : c("", !0),
        e.value.style.layout.plots.giftWrap.show ? (s(), r("g", _t, [
          (s(!0), r(N, null, W(z.value, (t, o) => (s(), r("g", null, [
            t.plots.length > 2 ? (s(), r("polygon", {
              key: 0,
              points: d(tt)({ series: t.plots }),
              fill: `${t.color}${d(de)[e.value.style.layout.plots.giftWrap.fillOpacity * 100]}`,
              "stroke-width": e.value.style.layout.plots.giftWrap.strokeWidth,
              "stroke-dasharray": e.value.style.layout.plots.giftWrap.strokeDasharray,
              stroke: t.color,
              "stroke-linejoin": "round",
              "stroke-linecap": "round"
            }, null, 8, wt)) : c("", !0)
          ]))), 256))
        ])) : c("", !0),
        (s(!0), r(N, null, W(z.value, (t, o) => (s(), r("g", null, [
          !t.shape || t.shape === "circle" ? (s(), r("g", $t, [
            (s(!0), r(N, null, W(t.plots, (a, n) => (s(), r("circle", {
              cx: a.x,
              cy: a.y,
              r: T.value && T.value === a.id ? a.weight * 2 : a.weight,
              fill: `${t.color}${d(de)[e.value.style.layout.plots.opacity * 100]}`,
              stroke: e.value.style.layout.plots.stroke,
              "stroke-width": e.value.style.layout.plots.strokeWidth,
              onMouseover: (x) => $e(a, o),
              onMouseleave: Me,
              style: D(`opacity:${T.value && T.value === a.id ? 1 : e.value.style.layout.plots.significance.useDistanceOpacity ? 1 - Math.abs(a.deviation) / _e.value : e.value.style.layout.plots.significance.show && Math.abs(a.deviation) > e.value.style.layout.plots.significance.deviationThreshold ? e.value.style.layout.plots.significance.opacity : 1}`)
            }, null, 44, Mt))), 256))
          ])) : (s(), r("g", Ct, [
            (s(!0), r(N, null, W(t.plots, (a, n) => (s(), J(Ne, {
              plot: { x: a.x, y: a.y },
              radius: T.value && T.value === a.id ? a.weight * 2 : a.weight,
              shape: t.shape,
              color: `${t.color}${d(de)[e.value.style.layout.plots.opacity * 100]}`,
              stroke: e.value.style.layout.plots.stroke,
              strokeWidth: e.value.style.layout.plots.strokeWidth,
              onMouseover: (x) => $e(a, o),
              onMouseleave: Me,
              style: D(`opacity:${T.value && T.value === a.id ? 1 : e.value.style.layout.plots.significance.useDistanceOpacity ? 1 - Math.abs(a.deviation) / _e.value : e.value.style.layout.plots.significance.show && Math.abs(a.deviation) > e.value.style.layout.plots.significance.deviationThreshold ? e.value.style.layout.plots.significance.opacity : 1}`)
            }, null, 8, ["plot", "radius", "shape", "color", "stroke", "strokeWidth", "onMouseover", "style"]))), 256))
          ]))
        ]))), 256)),
        e.value.style.layout.marginalBars.show ? (s(), r("g", zt, [
          v("defs", null, [
            v("linearGradient", {
              id: `marginal_x_${M.value}`,
              x1: "0%",
              y1: "0%",
              x2: "0%",
              y2: "100%"
            }, [
              v("stop", {
                offset: "0%",
                "stop-color": e.value.style.layout.marginalBars.fill
              }, null, 8, Lt),
              v("stop", {
                offset: "100%",
                "stop-color": e.value.style.backgroundColor
              }, null, 8, At)
            ], 8, St),
            v("linearGradient", {
              id: `marginal_y_${M.value}`,
              x1: "0%",
              x2: "100%",
              y1: "0%",
              y2: "0%"
            }, [
              v("stop", {
                offset: "0%",
                "stop-color": e.value.style.backgroundColor
              }, null, 8, Bt),
              v("stop", {
                offset: "100%",
                "stop-color": e.value.style.layout.marginalBars.fill
              }, null, 8, Nt)
            ], 8, Tt)
          ]),
          (s(!0), r(N, null, W(S.value.x, (t, o) => (s(), r("g", null, [
            t && S.value.avgX[o] ? (s(), r("rect", {
              key: 0,
              x: S.value.avgX[o] - u.value.width / I.value / 2,
              y: u.value.top - e.value.style.layout.marginalBars.offset - t / S.value.maxX * e.value.style.layout.marginalBars.size,
              width: u.value.width / I.value <= 0 ? 1e-4 : u.value.width / I.value,
              height: t / S.value.maxX * e.value.style.layout.marginalBars.size <= 0 ? 1e-4 : t / S.value.maxX * e.value.style.layout.marginalBars.size,
              fill: e.value.style.layout.marginalBars.useGradient ? `url(#marginal_x_${M.value})` : e.value.style.layout.marginalBars.fill,
              style: D(`opacity:${e.value.style.layout.marginalBars.opacity}`),
              stroke: e.value.style.backgroundColor,
              "stroke-width": e.value.style.layout.marginalBars.strokeWidth,
              rx: e.value.style.layout.marginalBars.borderRadius
            }, null, 12, Pt)) : c("", !0)
          ]))), 256)),
          (s(!0), r(N, null, W(S.value.y, (t, o) => (s(), r("g", null, [
            t && S.value.avgY[o] ? (s(), r("rect", {
              key: 0,
              x: u.value.right + e.value.style.layout.marginalBars.offset,
              y: S.value.avgY[o] - u.value.height / I.value / 2,
              height: u.value.height / I.value <= 0 ? 1e-4 : u.value.height / I.value,
              width: t / S.value.maxY * e.value.style.layout.marginalBars.size <= 0 ? 1e-4 : t / S.value.maxY * e.value.style.layout.marginalBars.size,
              fill: e.value.style.layout.marginalBars.useGradient ? `url(#marginal_y_${M.value})` : e.value.style.layout.marginalBars.fill,
              style: D(`opacity:${e.value.style.layout.marginalBars.opacity}`),
              stroke: e.value.style.backgroundColor,
              "stroke-width": e.value.style.layout.marginalBars.strokeWidth,
              rx: e.value.style.layout.marginalBars.borderRadius
            }, null, 12, Wt)) : c("", !0)
          ]))), 256)),
          e.value.style.layout.marginalBars.showLines ? (s(), r("g", Ft, [
            (s(!0), r(N, null, W(Ye.value, (t) => (s(), r(N, null, [
              g.value.includes(t.id) ? c("", !0) : (s(), r("path", {
                key: 0,
                d: `M ${t.dX}`,
                stroke: e.value.style.backgroundColor,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth + 1,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, Ot)),
              g.value.includes(t.id) ? c("", !0) : (s(), r("path", {
                key: 1,
                d: `M ${t.dX}`,
                stroke: t.color,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, Xt)),
              g.value.includes(t.id) ? c("", !0) : (s(), r("path", {
                key: 2,
                d: `M ${t.dY}`,
                stroke: e.value.style.backgroundColor,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth + 1,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, It)),
              g.value.includes(t.id) ? c("", !0) : (s(), r("path", {
                key: 3,
                d: `M ${t.dY}`,
                stroke: t.color,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, Dt))
            ], 64))), 256))
          ])) : c("", !0)
        ])) : c("", !0),
        y.value && e.value.style.layout.plots.selectors.show ? (s(), r("g", Yt, [
          v("line", {
            x1: p.value.x,
            x2: y.value.x,
            y1: y.value.y,
            y2: y.value.y,
            stroke: e.value.style.layout.plots.selectors.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.strokeWidth,
            "stroke-dasharray": e.value.style.layout.plots.selectors.strokeDasharray,
            "stroke-linecap": "round",
            class: "line-pointer"
          }, null, 8, jt),
          v("line", {
            x1: y.value.x,
            x2: y.value.x,
            y1: p.value.y,
            y2: y.value.y,
            stroke: e.value.style.layout.plots.selectors.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.strokeWidth,
            "stroke-dasharray": e.value.style.layout.plots.selectors.strokeDasharray,
            "stroke-linecap": "round",
            class: "line-pointer"
          }, null, 8, Et),
          v("text", {
            x: p.value.x + (y.value.x > p.value.x ? -6 : 6),
            y: y.value.y + e.value.style.layout.plots.selectors.labels.fontSize / 3,
            "font-size": e.value.style.layout.plots.selectors.labels.fontSize,
            fill: e.value.style.layout.plots.selectors.labels.color,
            "font-weight": e.value.style.layout.plots.selectors.labels.bold ? "bold" : "normal",
            "text-anchor": y.value.x > p.value.x ? "end" : "start"
          }, $(d(Y)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            y.value.v.y,
            d(F)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: y.value.v.y,
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.plots.selectors.labels.rounding
            }),
            { datapoint: y.value }
          )), 9, Vt),
          v("text", {
            x: y.value.x,
            y: p.value.y + (y.value.y > p.value.y ? -6 : e.value.style.layout.plots.selectors.labels.fontSize + 6),
            "font-size": e.value.style.layout.plots.selectors.labels.fontSize,
            fill: e.value.style.layout.plots.selectors.labels.color,
            "font-weight": e.value.style.layout.plots.selectors.labels.bold ? "bold" : "normal",
            "text-anchor": "middle"
          }, $(d(Y)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            y.value.v.x,
            d(F)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: y.value.v.x,
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.plots.selectors.labels.rounding
            }),
            { datapoint: y.value }
          )), 9, Gt),
          v("circle", {
            cx: p.value.x,
            cy: y.value.y,
            r: e.value.style.layout.plots.selectors.markers.radius,
            fill: e.value.style.layout.plots.selectors.markers.fill,
            stroke: e.value.style.layout.plots.selectors.markers.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.markers.strokeWidth,
            class: "line-pointer"
          }, null, 8, Rt),
          v("circle", {
            cx: y.value.x,
            cy: p.value.y,
            r: e.value.style.layout.plots.selectors.markers.radius,
            fill: e.value.style.layout.plots.selectors.markers.fill,
            stroke: e.value.style.layout.plots.selectors.markers.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.markers.strokeWidth,
            class: "line-pointer"
          }, null, 8, qt),
          e.value.style.layout.plots.selectors.labels.showName ? (s(), r("text", {
            key: 0,
            x: y.value.x,
            y: y.value.y + (y.value.y < p.value.y ? -e.value.style.layout.plots.selectors.labels.fontSize / 2 : e.value.style.layout.plots.selectors.labels.fontSize),
            "font-size": e.value.style.layout.plots.selectors.labels.fontSize,
            fill: e.value.style.layout.plots.selectors.labels.color,
            "font-weight": e.value.style.layout.plots.selectors.labels.bold ? "bold" : "normal",
            "text-anchor": y.value.x < u.value.left + 100 ? "start" : y.value.x > u.value.right - 100 ? "end" : y.value.x > p.value.x ? "start" : "end"
          }, $(y.value.v.name), 9, Ut)) : c("", !0)
        ])) : c("", !0),
        e.value.style.layout.dataLabels.xAxis.show ? (s(), r("g", Ht, [
          v("text", {
            x: u.value.left - 5,
            y: p.value.y + e.value.style.layout.dataLabels.xAxis.fontSize / 3,
            "text-anchor": "end",
            "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
            fill: e.value.style.layout.dataLabels.xAxis.color
          }, $(d(Y)(
            e.value.style.layout.plots.selectors.labels.x.formatter,
            h.value.xMin,
            d(F)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: h.value.xMin,
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.xAxis.rounding
            })
          )), 9, Jt),
          v("text", {
            x: u.value.right + 3,
            y: p.value.y + e.value.style.layout.dataLabels.xAxis.fontSize / 3,
            "text-anchor": "start",
            "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
            fill: e.value.style.layout.dataLabels.xAxis.color
          }, $(d(Y)(
            e.value.style.layout.plots.selectors.labels.x.formatter,
            h.value.xMax,
            d(F)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: h.value.xMax,
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.xAxis.rounding
            })
          )), 9, Kt),
          v("text", {
            id: `vue-ui-scatter-xAxis-label-${M.value}`,
            transform: `translate(${e.value.style.layout.dataLabels.xAxis.fontSize * 2}, ${u.value.top + u.value.height / 2}), rotate(-90)`,
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
            "font-weight": e.value.style.layout.dataLabels.xAxis.bold ? "bold" : "normal",
            fill: e.value.style.layout.dataLabels.xAxis.color
          }, $(e.value.style.layout.dataLabels.xAxis.name), 9, Qt)
        ])) : c("", !0),
        e.value.style.layout.dataLabels.yAxis.show ? (s(), r("g", Zt, [
          v("text", {
            x: p.value.x,
            y: u.value.bottom + e.value.style.layout.dataLabels.yAxis.fontSize + 3,
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
            fill: e.value.style.layout.dataLabels.yAxis.color
          }, $(d(Y)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            h.value.yMin,
            d(F)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: h.value.yMin,
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.yAxis.rounding
            })
          )), 9, el),
          v("text", {
            x: p.value.x,
            y: u.value.top - e.value.style.layout.dataLabels.yAxis.fontSize / 2,
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
            fill: e.value.style.layout.dataLabels.yAxis.color
          }, $(d(Y)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            h.value.yMax,
            d(F)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: h.value.yMax,
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.yAxis.rounding
            })
          )), 9, tl),
          v("text", {
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
            "font-weight": e.value.style.layout.dataLabels.yAxis.bold ? "bold" : "normal",
            fill: e.value.style.layout.dataLabels.yAxis.color,
            x: u.value.left + u.value.width / 2,
            y: u.value.bottom + 8 + e.value.style.layout.dataLabels.yAxis.fontSize * 2
          }, $(e.value.style.layout.dataLabels.yAxis.name), 9, ll)
        ])) : c("", !0),
        v("clipPath", {
          id: `clip_path_${M.value}`
        }, [
          v("rect", {
            x: u.value.left,
            y: u.value.top,
            width: u.value.width <= 0 ? 1e-4 : u.value.width,
            height: u.value.height <= 0 ? 1e-4 : u.value.height
          }, null, 8, ol)
        ], 8, al),
        e.value.style.layout.correlation.show ? (s(), r("g", sl, [
          (s(!0), r(N, null, W(z.value, (t, o) => (s(), r("line", {
            x1: t.correlation.x1,
            x2: t.correlation.x2,
            y1: t.correlation.y1,
            y2: t.correlation.y2,
            "stroke-dasharray": e.value.style.layout.correlation.strokeDasharray,
            stroke: t.color,
            "stroke-width": e.value.style.layout.correlation.strokeWidth,
            "clip-path": `url(#clip_path_${M.value})`
          }, null, 8, ul))), 256)),
          (s(!0), r(N, null, W(z.value, (t, o) => (s(), r("g", null, [
            e.value.style.layout.correlation.label.show ? (s(), r("text", {
              key: 0,
              x: t.label.x,
              y: t.label.y,
              fill: e.value.style.layout.correlation.label.useSerieColor ? t.color : e.value.style.layout.correlation.label.color,
              "font-size": e.value.style.layout.correlation.label.fontSize,
              "font-weight": e.value.style.layout.correlation.label.bold ? "bold" : "normal"
            }, $(Number(t.correlation.coefficient.toFixed(e.value.style.layout.correlation.label.roundingValue)).toLocaleString()), 9, rl)) : c("", !0)
          ]))), 256))
        ])) : c("", !0),
        A(l.$slots, "svg", { svg: C.value }, void 0, !0)
      ], 14, xt)) : c("", !0),
      l.$slots.watermark ? (s(), r("div", il, [
        A(l.$slots, "watermark", ae(oe({ isPrinting: d(ge) || d(xe) })), void 0, !0)
      ])) : c("", !0),
      K.value ? c("", !0) : (s(), J(ht, {
        key: 4,
        config: {
          type: "quadrant",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            quadrant: {
              grid: {
                color: e.value.style.layout.axis.stroke
              },
              plots: {
                color: e.value.style.layout.axis.stroke,
                radius: 1
              }
            }
          }
        }
      }, null, 8, ["config"])),
      v("div", {
        ref_key: "chartLegend",
        ref: fe
      }, [
        e.value.style.legend.show ? (s(), J(ct, {
          key: 0,
          legendSet: j.value,
          config: Ie.value,
          onClickMarker: i[0] || (i[0] = ({ legend: t }) => Ce(t.id))
        }, {
          item: w(({ legend: t }) => [
            v("div", {
              onClick: (o) => t.segregate(),
              style: D(`opacity:${g.value.includes(t.id) ? 0.5 : 1}`)
            }, $(t.name), 13, nl)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : A(l.$slots, "legend", {
          key: 1,
          legend: j.value
        }, void 0, !0)
      ], 512),
      le(vt, {
        show: X.value.showTooltip && se.value,
        backgroundColor: e.value.style.tooltip.backgroundColor,
        color: e.value.style.tooltip.color,
        borderRadius: e.value.style.tooltip.borderRadius,
        borderColor: e.value.style.tooltip.borderColor,
        borderWidth: e.value.style.tooltip.borderWidth,
        fontSize: e.value.style.tooltip.fontSize,
        backgroundOpacity: e.value.style.tooltip.backgroundOpacity,
        position: e.value.style.tooltip.position,
        offsetY: e.value.style.tooltip.offsetY,
        parent: U.value,
        content: ue.value,
        isCustom: e.value.style.tooltip.customFormat && typeof e.value.style.tooltip.customFormat == "function"
      }, {
        "tooltip-before": w(() => [
          A(l.$slots, "tooltip-before", ae(oe({ ...ie.value })), void 0, !0)
        ]),
        "tooltip-after": w(() => [
          A(l.$slots, "tooltip-after", ae(oe({ ...ie.value })), void 0, !0)
        ]),
        default: w(() => [
          e.value.style.tooltip.showShape ? (s(), r("div", yl, [
            (s(), r("svg", vl, [
              le(Ne, {
                shape: y.value.shape,
                color: y.value.color,
                plot: { x: 10, y: 10 },
                radius: 7
              }, null, 8, ["shape", "color"])
            ]))
          ])) : c("", !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isCustom"]),
      K.value ? (s(), J(pt, {
        key: 5,
        hideDetails: "",
        config: {
          open: X.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          },
          head: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          }
        }
      }, {
        content: w(() => [
          le(dt, {
            colNames: ee.value.colNames,
            head: ee.value.head,
            body: ee.value.body,
            config: ee.value.config,
            title: `${e.value.style.title.text}${e.value.style.title.subtitle.text ? ` : ${e.value.style.title.subtitle.text}` : ""}`,
            onClose: i[1] || (i[1] = (t) => X.value.showTable = !1)
          }, {
            th: w(({ th: t }) => [
              Re($(t), 1)
            ]),
            td: w(({ td: t }) => [
              t.shape ? (s(), r("div", cl, [
                v("span", null, $(t.content), 1)
              ])) : (s(), r("div", {
                key: 1,
                innerHTML: t
              }, null, 8, dl))
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"])
        ]),
        _: 1
      }, 8, ["config"])) : c("", !0)
    ], 14, gt));
  }
}, Sl = /* @__PURE__ */ ft(hl, [["__scopeId", "data-v-4009bc76"]]);
export {
  Sl as default
};
